<%@page contentType="text/xml"%><%@page pageEncoding="UTF-8" import="java.io.*,java.util.*,java.net.*,com.smallx.xml.infoset.*,com.smallx.xml.infoset.util.*,com.smallx.xml.infoset.sax.*,com.oreilly.servlet.*"%><%
   ServletContext context = getServletContext();
   String repository = context.getRealPath("WEB-INF/tmp");

   MultipartRequest mrequest = new MultipartRequest(request,repository);

   File xmlFile = mrequest.getFile("file");
   String urlString = mrequest.getParameter("url");
   
   if (xmlFile==null || urlString==null) {
      %>
      <input-error>
      <missing>An XML file must be selected.</missing>
      <missing>A URL must be entered.</missing>
      </input-error>
      <%
      return;
   }

   
   StringBuffer docStringBuffer = new StringBuffer();
   try {
      FileReader r = new FileReader(xmlFile);
      char [] buffer = new char[1024];
      int len;
      while ((len=r.read(buffer))>0) {
         docStringBuffer.append(buffer,0,len);
      }
      r.close();
   } catch (java.io.IOException ex) {
      context.log("I/O error while reading input XML document.",ex);
      return;
   }
   String docString = docStringBuffer.toString();
   
   SAXDocumentLoader loader = null;
   try {
      loader = new SAXDocumentLoader();
   } catch (Exception ex) {
      context.log("Cannot instantiate SAXDocumentLoader.",ex);
      return;
   }
   
   String value = mrequest.getParameter("parse");
   if (value!=null && value.equals("parse")) {
      try {
         loader.generate(new StringReader(docString),new NullDestination());
      } catch (XMLException ex) {
         %>
         <input-error>
         <error><%=ex.getMessage()%></error>
         </input-error>
         <%
         return;
      } catch (IOException ex) {
         // Never happen with StringReader
      }
   }
   
   try {
      URL post = new URL(urlString);
      URLConnection connection = post.openConnection();
      connection.setDoOutput(true);
      connection.setRequestProperty("Content-Type","text/xml");
      OutputStream os = connection.getOutputStream();
      OutputStreamWriter w = new OutputStreamWriter(os);
      w.write(docString);
      w.close();
      boolean ok = true;
      if (connection instanceof HttpURLConnection) {
         ok = ((HttpURLConnection)connection).getResponseCode()==HttpURLConnection.HTTP_OK;
      }
      if (ok) {
         InputStream is = connection.getInputStream();
         String contentType = connection.getContentType();
         if (contentType!=null) {
            int semicolon = contentType.indexOf(';');
            if (semicolon>=0) {
               contentType = contentType.substring(0,semicolon);
            }
            if (!contentType.equals("text/xml")) {
               %><output-error><error>Response content type is not XML: <%=contentType%></error></output-error><%
               return;
            }
         }
         InputStreamReader r = new InputStreamReader(is);
         String output = null;
         try {
            /*
            StringWriter sw = new StringWriter();
            loader.generate(r,new WriterItemDestination(sw,null) {
               public void xmlDeclaration(Writer output,String version, String encoding) {
               }
            });
            output = sw.toString();*/
            StringBuffer sb = new StringBuffer();
            char [] cbuffer = new char[1024];
            int len;
            while ((len=r.read(cbuffer))>0) {
               sb.append(cbuffer,0,len);
            }
            output = sb.toString();
         //} catch (XMLException ex) {
         //   % ><output-error><error>Error in XML Parse of output: <%=ex.getMessage()% ></error></output-error>< %
         //   return;
         } catch (IOException ex) {
            %><output-error><error>I/O error during XML Parse of output: <%=ex.getMessage()%></error></output-error><%
            return;
         }
         value = mrequest.getParameter("format");
         // shut this off for now
         value = null;
         if (value!=null && value.equals("format")) {
            %><output-document><%
            out.write(output);
            %></output-document><%
         } else {
            response.setContentType("text/xml");
            out.write(output);
         }
         r.close();
      } else {
         %><output-error><error>URL resource responded with an error.</error></output-error><%
      }
   } catch (MalformedURLException ex) {
      %>
      <input-error><error>Bad input URL: <%=mrequest.getParameter("url")%></error></input-error>
      <%
   } catch (IOException ex) {
      %>
      <output-error><error>I/O error while communicating with URL: <%=ex.getMessage()%></error></output-error>
      <%
   }
%>
