<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" 
   xmlns:c="urn:publicid:IDN+smallx.com:examples:contacts:1.0"
   xmlns="http://www.w3.org/1999/xhtml"
>

<xsl:output method="html"/>
<xsl:param name="context"/>
<xsl:param name="style"/>

<xsl:template match="contact-app">
<html>
   <head>
   <title>Contacts</title>
   </head>
   <body>
   <xsl:apply-templates/>
   </body>
</html>
</xsl:template>

<xsl:template match="contacts">
<xsl:apply-templates mode="list"/>
</xsl:template>

<xsl:template match="current">
<p><a href="{$style}.pd">Return to List</a></p>
<hr/>
<xsl:apply-templates/>
<hr/>
<p><a href="{$style}.pd">Return to List</a></p>
</xsl:template>

<xsl:template match="current/contacts">
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="contact" mode="list">
<p><xsl:apply-templates mode="list"/></p>
</xsl:template>

<xsl:template match="contact/name" mode="list">
<a href="{$style}.get?last={last}&amp;first={first}&amp;contact-only=true"><xsl:apply-templates select="last"/>, <xsl:apply-templates select="first"/></a>
</xsl:template>

<xsl:template match="contact">
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="first">
<xsl:apply-templates/>
<xsl:text> </xsl:text>
</xsl:template>

<xsl:template match="contact/*">
<p><span class="label"><xsl:value-of select="translate(substring(local-name(.),1,1),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/><xsl:value-of select="substring(local-name(.),2)"/>:</span><xsl:text> </xsl:text><xsl:apply-templates/></p>
</xsl:template>

<!--
<xsl:template match="@*|*">
<xsl:copy>
<xsl:apply-templates select="node()|@*"/>
</xsl:copy>
</xsl:template>
-->

</xsl:stylesheet>
