<?xml version="1.0" encoding="UTF-8" ?>

<!--
    Document   : test.xsl
    Created on : November 15, 2004, 6:21 PM
    Author     : alex
    Description:
        Purpose of transformation follows.
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="html"/>

<xsl:template match="doc">
  <html>
      <head>
          <xsl:apply-templates select="title" mode="copy"/>
      </head>
      <body>
      <xsl:apply-templates/>
      </body>
  </html>
</xsl:template>

<xsl:template match="doc/title">
<h1><xsl:apply-templates/></h1>
</xsl:template>

<xsl:template match="include">
<xsl:apply-templates select="document(@href)" mode="strip-top"/>
</xsl:template>

<xsl:template match="doc" mode="strip-top">
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="*|@*">
<xsl:copy>
<xsl:apply-templates select="@*|node()"/>
</xsl:copy>
</xsl:template>

<xsl:template match="*|@*" mode="copy">
<xsl:copy>
<xsl:apply-templates select="@*|node()"/>
</xsl:copy>
</xsl:template>

</xsl:stylesheet>

